#include "selenite/palette.h"
#include "rei-json/Object.h"
#include "rei-json/json.h"
#include <fstream>
#include <optional>
#include <sstream>
#include <string>

namespace selenite
{
Color hexStringToColor(const std::string &hexString)
{
	int r, g, b;
	std::sscanf(hexString.c_str(), "#%02x%02x%02x", &r, &g, &b);
	return {
		.r = r,
		.g = g,
		.b = b,
		.hex = hexString,
	};
}

std::optional<Palette> parseJson(const std::string &path)
{
	std::ifstream file(path);
	if (!file) {
		return std::nullopt;
	}

	std::stringstream buffer;
	buffer << file.rdbuf();
	auto jsonStr = buffer.str();

	auto jsonOpt = rei::json::parse(jsonStr);
	auto json = std::get<rei::json::JsonObject>(jsonOpt);

	/*if (!json.is_object() || !json["primary"].is_string() || !json["secondary"].is_string() ||*/
	/*!json["background"].is_string() || !json["background2"].is_string() ||*/
	/*!json["background4"].is_string() || !json["background3"].is_string() ||*/
	/*!json["pane"].is_string() || !json["foreground"].is_string() ||*/
	/*!json["foregroundHint"].is_string() || !json["green"].is_string() ||*/
	/*!json["orange"].is_string() || !json["red"].is_string()) {*/
	/*return std::nullopt;*/
	/*}*/

	Palette palette{
		.primary = hexStringToColor(json.getString("primary")),
		.secondary = hexStringToColor(json.getString("secondary")),
		.background = hexStringToColor(json.getString("background")),
		.background2 = hexStringToColor(json.getString("background2")),
		.background3 = hexStringToColor(json.getString("background3")),
		.background4 = hexStringToColor(json.getString("background4")),
		.pane = hexStringToColor(json.getString("pane")),
		.foreground = hexStringToColor(json.getString("foreground")),
		.foregroundHint = hexStringToColor(json.getString("foregroundHint")),
		.green = hexStringToColor(json.getString("green")),
		.orange = hexStringToColor(json.getString("orange")),
		.red = hexStringToColor(json.getString("red")),
	};
	return palette;
}
} // namespace selenite
